# Online repository for the PhenoPop method. 
The PhenoPop method is available through the function "PhenoPop(experiment_name, NR, Concentration_array, Time_array, datafile)". 
See "example.m" or the Wiki pages for specifications on how to run the method. 

The Wiki pages also contain documentation on how to reproduce the figures in the article "Phenotypic deconvolution in heterogeneous cancer cell populations using drug screening data"

Author list: 
A. Köhn-Luque\*, E. M. Myklebust\*, D. S. Tadele, M. Giliberto, J. Noory, E. Harivel, P. Arsenteva, S.M. Mumenthaler, F. Schjesvold, K. Taskén, J. M. Enserink, K. Leder†, A. Frigessi†, and J. Foo†.

\*: These authors contributed equally.

†: These authors contributed equally.

Abstract: 
Tumor heterogeneity is an important driver of tumor recurrence, as treatments that initially elicit clinical responses can select for drug-tolerant tumor subpopulations, leading to the outgrowth of resistant clones and cancer treatment failure. Profiling the drug-response heterogeneity of tumor samples using traditional genomic deconvolution methods has yielded limited results, due in part to the imperfect mapping between genomic variation and functional characteristics. Here, by introducing an underlying population dynamic model of tumor subclonal response to therapy, we enable the phenotypic deconvolution of bulk drug response data into component subpopulations, and the estimation of their differential drug sensitivities and population frequencies. We used this method, called PhenoPop, to perform deconvolution on tumor drug screening data generated both experimentally and in silico. This study demonstrates how mechanistic population modeling can be leveraged to develop statistical frameworks for profiling phenotypic heterogeneity from bulk tumor samples and to perform individualized patient treatment predictions.
